unit rDBGrid_DTEdit;

{<
  rDBGrid_DTEdit is design time dialog used by rDBGrid component.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
  @lastmod(Dec 2018)
}

interface

{$INCLUDE _delphi_ver.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DBGrids, rDBGrid, db, CheckLst, ComCtrls,
{$IFDEF DXE2P} UITypes, Types, {$ENDIF}
  ExtCtrls, IniFiles, rImprovedComps, PropSaveMain, Grids, rHTMLLabel;

type
  { design time dialog used by rDBGrid component }
  TrDBGrid_DTEditForm = class(TForm)
    pc: TPageControl;
    tsCol: TTabSheet;
    tsTag: TTabSheet;
    gbActions: TGroupBox;
    gbEdit: TGroupBox;
    chAdd: TCheckBox;
    chEdit: TCheckBox;
    chDuplic: TCheckBox;
    chDelete: TCheckBox;
    chSaveAdd: TCheckBox;
    chAutoEdit: TCheckBox;
    chEditGroup: TCheckBox;
    gbTools: TGroupBox;
    chSort: TCheckBox;
    chFilter: TCheckBox;
    chColumn: TCheckBox;
    chClose: TCheckBox;
    chEnaAll: TCheckBox;
    tsLink: TTabSheet;
    Label10: TrHTMLLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    chProps: TCheckBox;
    PSFile: TPropSaveFile;
    PSMain: TPropSaveMain;
    gbEmpty: TrGroupBox;
    btClose: TButton;
    gbLeft1: TrGroupBox;
    Label1: TrHTMLLabel;
    lbFields: TrListBox;
    btMove: TButton;
    btMoveAll: TButton;
    Label3: TrHTMLLabel;
    eSep: TEdit;
    gbRight1: TrGroupBox;
    Label2: TrHTMLLabel;
    lbCol: TrCheckListBox;
    btUp: TButton;
    btDown: TButton;
    btDel: TButton;
    btDelAll: TButton;
    btDelNoField: TButton;
    gbColBottom: TrGroupBox;
    lFld: TrHTMLLabel;
    lTitle: TrHTMLLabel;
    eTitle: TEdit;
    chReadOnly: TCheckBox;
    btNext: TButton;
    lblFName: TrHTMLLabel;
    gbLeft2: TrGroupBox;
    gbRight2: TrGroupBox;
    Label6: TrHTMLLabel;
    lbLink: TrCheckListBox;
    Label12: TrHTMLLabel;
    cbLinkType: TrComboBoxEx;
    Label19: TrHTMLLabel;
    Label7: TrHTMLLabel;
    lbBool: TrCheckListBox;
    Label8: TrHTMLLabel;
    Label20: TrHTMLLabel;
    eBoolVal: TEdit;
    Label9: TrHTMLLabel;
    gbLeft3: TrGroupBox;
    gbRight3: TrGroupBox;
    Label11: TrHTMLLabel;
    lbPick: TrCheckListBox;
    Label24: TrHTMLLabel;
    lbColor: TrCheckListBox;
    gbLeft4: TrGroupBox;
    gbRight4: TrGroupBox;
    Label13: TrHTMLLabel;
    lbTitleImg: TrCheckListBox;
    Label17: TrHTMLLabel;
    Label18: TrHTMLLabel;
    cbDataImg: TrComboBoxEx;
    lbDataImg: TrListBox;
    btDAdd: TButton;
    btDDel: TButton;
    rGroupBox2: TrGroupBox;
    Label14: TrHTMLLabel;
    eTitleImg: TrEditNum;
    UpDownTitleImg: TUpDown;
    TitleImg: TImage;
    rGroupBox3: TrGroupBox;
    DataImg: TImage;
    lDataImgVal: TrHTMLLabel;
    lDataImgIdx: TrHTMLLabel;
    Label22: TrHTMLLabel;
    lDataImgText: TrHTMLLabel;
    eDataImgVal: TrComboBoxEx;
    eDataImgIdx: TrEditNum;
    UpDownDataImg: TUpDown;
    eDataImgText: TEdit;
    Label4: TrHTMLLabel;
    TabSheet3: TTabSheet;
    lbDrawPick: TrCheckListBox;
    Label5: TrHTMLLabel;
    rHTMLLabel1: TrHTMLLabel;
    gbLeft5: TrGroupBox;
    Label15: TrHTMLLabel;
    lbDate: TrCheckListBox;
    gbRight5: TrGroupBox;
    Label21: TrHTMLLabel;
    Label23: TrHTMLLabel;
    lbGraphics: TrCheckListBox;
    Label16: TrHTMLLabel;
    TabSheet4: TTabSheet;
    gbRight6: TrGroupBox;
    Label25: TrHTMLLabel;
    Label26: TrHTMLLabel;
    Label27: TrHTMLLabel;
    lbHints: TrCheckListBox;
    eHint: TEdit;
    gbLeft6: TrGroupBox;
    Label28: TrHTMLLabel;
    lbFilterFields: TrCheckListBox;
    btCollapse: TButton;
    btExpand: TButton;
    tsGroup: TTabSheet;
    gbLeftGroups: TrGroupBox;
    Label29: TrHTMLLabel;
    lbGroups: TrListBox;
    btNewGroup: TButton;
    btDelGroup: TButton;
    gbGroupBottom: TrGroupBox;
    Label31: TrHTMLLabel;
    eGroupTitle: TEdit;
    cgGroupTitleColor: TrColorBox;
    Label32: TrHTMLLabel;
    gbRightGroups: TrGroupBox;
    Label33: TrHTMLLabel;
    lbGroupFields: TrCheckListBox;
    btGroupUpdate: TButton;
    rGroupBox1: TrGroupBox;
    Label34: TrHTMLLabel;
    cbGroupMaster: TrComboBoxEx;
    btGroupUpdateAll: TButton;
    Label35: TrHTMLLabel;
    cgGroupLineColor: TrColorBox;
    btNone1: TrURLLabel;
    btNone2: TrURLLabel;
    btGroupCollapse: TButton;
    btGroupExpand: TButton;
    Label36: TrHTMLLabel;
    eGroupMasterMask: TEdit;
    lblInfo1: TrHTMLLabel;
    lblInfo2: TrHTMLLabel;
    chGroupLock: TCheckBox;
    btGroupAddMask: TrHTMLLabel;
    lblInfoSep: TrHTMLLabel;
    TabSheet5: TTabSheet;
    gbLeft7: TrGroupBox;
    Label37: TrHTMLLabel;
    Label38: TrHTMLLabel;
    lbFooterFields: TrCheckListBox;
    gbRight7: TrGroupBox;
    Label39: TrHTMLLabel;
    Label40: TrHTMLLabel;
    Label41: TrHTMLLabel;
    lblTest: TrHTMLLabel;
    cbColor: TrColorBox;
    gbFontStyle: TGroupBox;
    chNormal: TCheckBox;
    chBold: TCheckBox;
    chItalic: TCheckBox;
    chUnderline: TCheckBox;
    eFontSize: TrEditNum;
    Label42: TrHTMLLabel;
    eFooterMask: TEdit;
    Label43: TrHTMLLabel;
    cbFooterTags: TrComboBoxEx;
    btAddFooterTag: TButton;
    chFooterOn: TCheckBox;
    gbAlignment: TRadioGroup;
    chFilterFunnelBtn: TCheckBox;
    chFilterTextBar: TCheckBox;
    rHTMLLabel2: TrHTMLLabel;
    chGrouppingOn: TCheckBox;
    tsBars: TTabSheet;
    gbLeft8: TrGroupBox;
    rHTMLLabel3: TrHTMLLabel;
    lbDataBar: TrCheckListBox;
    rGroupBox5: TrGroupBox;
    rHTMLLabel6: TrHTMLLabel;
    lbStatusBar: TrCheckListBox;
    gbDataBarParams: TrGroupBox;
    lblDataBarLimits: TrHTMLLabel;
    eDatabarMin: TrEditNum;
    eDatabarMax: TrEditNum;
    lblDatabarColor: TrHTMLLabel;
    cbDatabarColorFrom: TrColorBox;
    gbDatabarDemo: TrGroupBox;
    cbDatabarColorTo: TrColorBox;
    gbStatusBarParams: TrGroupBox;
    lblStatusMax: TrHTMLLabel;
    eStatusSteps: TrEditNum;
    lblStatusColor: TrHTMLLabel;
    cbStatusColorAll: TrColorBox;
    cbDataBarText: TComboBox;
    rHTMLLabel4: TrHTMLLabel;
    rHTMLLabel5: TrHTMLLabel;
    cbStatusColorDone: TrColorBox;
    rHTMLLabel7: TrHTMLLabel;
    cbStatusType: TComboBox;
    procedure chEditGroupClick(Sender: TObject);
    procedure chEnaAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure btUpClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure lbColClickCheck(Sender: TObject);
    procedure lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btDelClick(Sender: TObject);
    procedure btDelAllClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btMoveClick(Sender: TObject);
    procedure btMoveAllClick(Sender: TObject);
    procedure lbColClick(Sender: TObject);
    procedure eTitleChange(Sender: TObject);
    procedure eTitleEnter(Sender: TObject);
    procedure eTitleExit(Sender: TObject);
    procedure btNextClick(Sender: TObject);
    procedure lbBoolClick(Sender: TObject);
    procedure lbBoolClickCheck(Sender: TObject);
    procedure eBoolValExit(Sender: TObject);
    procedure btDelNoFieldClick(Sender: TObject);
    procedure lbLinkClickCheck(Sender: TObject);
    procedure lbLinkClick(Sender: TObject);
    procedure lbTitleImgClickCheck(Sender: TObject);
    procedure lbTitleImgClick(Sender: TObject);
    procedure eTitleImgExit(Sender: TObject);
    procedure cbLinkTypeExit(Sender: TObject);
    procedure eTitleImgChange(Sender: TObject);
    procedure cbDataImgChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbDataImgClick(Sender: TObject);
    procedure eDataImgValExit(Sender: TObject);
    procedure btDDelClick(Sender: TObject);
    procedure btDAddClick(Sender: TObject);
    procedure eDataImgIdxChange(Sender: TObject);
    procedure cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure chReadOnlyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lbPickClickCheck(Sender: TObject);
    procedure lbDrawPickClickCheck(Sender: TObject);
    procedure lbHintsClick(Sender: TObject);
    procedure lbHintsClickCheck(Sender: TObject);
    procedure eHintExit(Sender: TObject);
    procedure btCollapseClick(Sender: TObject);
    procedure lbGroupsClick(Sender: TObject);
    procedure btGroupUpdateClick(Sender: TObject);
    procedure btNewGroupClick(Sender: TObject);
    procedure btDelGroupClick(Sender: TObject);
    procedure lbGroupFieldsClickCheck(Sender: TObject);
    procedure cbGroupMasterChange(Sender: TObject);
    procedure btGroupUpdateAllClick(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure cgGroupTitleColorExit(Sender: TObject);
    procedure eGroupTitleEnter(Sender: TObject);
    procedure eGroupTitleExit(Sender: TObject);
    procedure btGroupCollapseClick(Sender: TObject);
    procedure Label22GetParameter(Sender: TObject; var ParamStr: string);
    procedure btGroupAddMaskAnchorClick(Sender: TObject; LinkName: string);
    procedure lbFooterFieldsClick(Sender: TObject);
    procedure lbFooterFieldsClickCheck(Sender: TObject);
    procedure btAddFooterTagClick(Sender: TObject);
    procedure chNormalClick(Sender: TObject);
    procedure lbDataImgDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure lbDataImgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure chFilterFunnelBtnClick(Sender: TObject);
    procedure chFilterTextBarClick(Sender: TObject);
    procedure chGrouppingOnClick(Sender: TObject);
    procedure chFooterOnClick(Sender: TObject);
    procedure lbDataBarClick(Sender: TObject);
    procedure lbDataBarClickCheck(Sender: TObject);
    procedure eDatabarMinExit(Sender: TObject);
    procedure lbStatusBarClick(Sender: TObject);
    procedure lbStatusBarClickCheck(Sender: TObject);
    procedure eStatusStepsExit(Sender: TObject);
  private
    Gr: TrDBGrid;
    Tag: Integer;
    Cs: TDBGridColumns;
    Flds: TFields;
    FAsLink: TStrings;
    FAsPick: TStrings;
    FAsColor: TStrings;
    FAsBool: TStrings;
    FAsDate: TStrings;
    FAsDataBar: TStrings;
    FAsStatusBar: TStrings;
    FAsGraphics: TStrings;
    FDrawDropDown: TStrings;
    FTitleHints: TStrings;
    FFilterBtn: TStrings;
    FTitleImgList: TImageList;
    FTitleImg: TStrings;
    FDataImgList: TImageList;
    FDataImg: TStrings;
    FDataImgIni: TMemIniFile;
    FFieldsGroups: TStrings;
    FFieldsGroupsIni: TMemIniFile;
    FFooterRow: TFooterRow;
    FOptionsEx2: TOptionsEx2;
    isFooterUpdating: Boolean;
    procedure LoadProps;
    procedure SetProps;
    procedure LoadCol(KeepSelected: Boolean);
    procedure AddCol(Fld: TField);
    procedure MoveICheckBox(List: TCheckListBox; old, new: Integer);
    procedure MoveIListBox(List: TListBox; old, new: Integer);
    procedure CheckI(act: Integer);
    procedure RefAll;
    procedure SetIniSection;
    procedure LoadDrawPick;
    procedure StoreDrawPick;
    procedure LoadGroups(KeepSelected: Boolean);
    procedure LoadGroupFields;
    function GetSelGroupName: string;
    procedure LoadFooterCfg(FieldName, Params: string);
    procedure UpdateFooterSetting;
    procedure RefDatabarDemo;
  public
  end;

  { initialize and show design time dialog }
function ShowrDBGridEditor(Component: TComponent): Boolean;

implementation

{$R *.dfm}

uses TypInfo, RosiCompGlobalCfg, rtool, rdlg, rpictool;

const
  cTag = 'Tag';

function ShowrDBGridEditor(Component: TComponent): Boolean;
var
  F: TrDBGrid_DTEditForm;
  DS: TDataSource;
begin
  Result:=true;
  F:=TrDBGrid_DTEditForm.Create(Application);
  try
    F.Caption:=Component.Name;
    F.Gr:=(Component as TrDBGrid);
    F.Tag:=GetOrdProp(Component, cTag);
    F.Cs:=GetObjectProp(Component, 'Columns') as TDBGridColumns;
    F.FAsLink:=GetObjectProp(Component, 'FieldsAsLink') as TStrings;
    F.FAsPick:=GetObjectProp(Component, 'FieldsAutoPickList') as TStrings;
    F.FAsColor:=GetObjectProp(Component, 'FieldsAsColor') as TStrings;
    F.FAsBool:=GetObjectProp(Component, 'FieldsAsBoolean') as TStrings;
    F.FAsDataBar:=GetObjectProp(Component, 'FieldsAsDataBar') as TStrings;
    F.FAsStatusBar:=GetObjectProp(Component, 'FieldsAsStatusBar') as TStrings;

    F.FAsDate:=GetObjectProp(Component, 'FieldsAsDate') as TStrings;
    F.FAsGraphics:=GetObjectProp(Component, 'FieldsAsGraphics') as TStrings;
    F.FDrawDropDown:=GetObjectProp(Component, 'FieldsDrawDropDown') as TStrings;
    F.FTitleHints:=GetObjectProp(Component, 'TitleHints') as TStrings;
    F.FFilterBtn:=GetObjectProp(Component, 'FieldsFilterButton') as TStrings;

    F.FTitleImg:=GetObjectProp(Component, 'TitleImages') as TStrings;
    F.FTitleImgList:=GetObjectProp(Component, 'TitleImageList') as TImageList;
    F.FDataImg:=GetObjectProp(Component, 'DataImages') as TStrings;
    F.FDataImgList:=GetObjectProp(Component, 'DataImageList') as TImageList;

    F.FFieldsGroups:=GetObjectProp(Component, 'FieldsGroups') as TStrings;
    F.FFooterRow:=GetObjectProp(Component, 'FooterRow') as TFooterRow;
    F.FOptionsEx2:=GetObjectProp(Component, 'OptionsEx2') as TOptionsEx2;

    F.Flds:=nil;
    try
      DS:=GetObjectProp(Component, 'DataSource') as TDataSource;
      if Assigned(DS) and Assigned(DS.DataSet) then
        F.Flds:=DS.DataSet.Fields;
    except
    end;
    F.ShowModal;
    SetOrdProp(Component, cTag, F.Tag);

    F.Gr.FixedGroupedCol(false);
  finally
    FreeAndNil(F);
  end;
  with (Component as TControl) do
    Invalidate;
end;

procedure TrDBGrid_DTEditForm.FormCreate(Sender: TObject);
begin
  FDataImgIni:=TMemIniFile.Create('');
  FFieldsGroupsIni:=TMemIniFile.Create('');
  PSFile.LoadFile(GetRosiCompIniFile);
  eDataImgVal.Items.Add(DataImagesFieldCfg);
  gbDataBarParams.Enabled:=false;
  gbStatusBarParams.Enabled:=false;
  cbFooterTags.Items.Clear;
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Sum);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Min);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Max);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_AVG);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountVal);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountNull);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountAll);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelSum);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelMin);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelMax);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelAVG);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountVal);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountNull);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountAll);
end;

procedure TrDBGrid_DTEditForm.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FDataImgIni);
  FreeAndNil(FFieldsGroupsIni);
end;

procedure TrDBGrid_DTEditForm.FormResize(Sender: TObject);
begin
  gbLeft1.Width:=pc.ClientWidth div 2;
  gbLeft2.Width:=pc.ClientWidth div 2;
  gbLeft3.Width:=pc.ClientWidth div 2;
  gbLeft4.Width:=pc.ClientWidth div 2;
  gbLeft5.Width:=pc.ClientWidth div 2;
  gbLeft6.Width:=pc.ClientWidth div 2;
  gbLeft7.Width:=pc.ClientWidth div 2;
  gbLeft8.Width:=pc.ClientWidth div 2;
  gbLeftGroups.Width:=pc.ClientWidth div 2 + 18;
end;

procedure TrDBGrid_DTEditForm.FormShow(Sender: TObject);
begin
  // pc.ActivePageIndex:=0;
  LoadProps;
end;

procedure TrDBGrid_DTEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetProps;
end;

procedure TrDBGrid_DTEditForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TrDBGrid_DTEditForm.btCollapseClick(Sender: TObject);
var
  F: TField;
begin
  if lbCol.ItemIndex < 0 then
    Exit;
  if not lbCol.Checked[lbCol.ItemIndex] then
    Exit;

  F:=Cs[lbCol.ItemIndex].Field;
  if Sender = btCollapse then
    Gr.CollapseGroup(F)
  else
    Gr.ExpandGroup(F);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.LoadProps;
var
  i, p: Integer;
  s: string;
begin
  // set actions controls
  chEnaAll.Checked:=Tag <> -1;
  if chEnaAll.Checked then
  begin
    chEditGroup.Checked:=Tag and 1 = 0;
    chSort.Checked:=Tag and 2 = 0;
    chFilter.Checked:=Tag and 4 = 0;
    chColumn.Checked:=Tag and 8 = 0;
    chProps.Checked:=Tag and 16 = 0;
    chClose.Checked:=Tag and 128 = 0;

    chAdd.Checked:=Tag and 1024 = 0;
    chDuplic.Checked:=Tag and 256 = 0;
    chEdit.Checked:=Tag and 2048 = 0;
    chDelete.Checked:=Tag and 4096 = 0;
    chSaveAdd.Checked:=Tag and 512 = 0;
    chAutoEdit.Checked:=Tag and 8192 = 0;
  end;
  chEnaAllClick(nil);
  chEditGroupClick(nil);
  // load fields
  lbFields.Clear;
  if Flds <> nil then
    for i:=0 to Flds.Count - 1 do
      lbFields.Items.Add(Flds[i].FieldName);
  LoadCol(false);
  RefAll;

  // load FieldsAsLink
  lbLink.Items.Assign(lbFields.Items);
  for i:=0 to FAsLink.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsLink.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsLink.Strings[i]:=s + '=' + cbLinkType.Items[0];
    // set lbLink
    p:=lbLink.Items.IndexOf(FAsLink.Names[i]);
    if p >= 0 then
      lbLink.Checked[p]:=true;
  end;

  // load FieldAsBool list
  lbBool.Items.Assign(lbFields.Items);
  for i:=0 to FAsBool.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsBool.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsBool.Strings[i]:=s + '=' + rDefBoolValue;
    // set lbBool
    p:=lbBool.Items.IndexOf(FAsBool.Names[i]);
    if p >= 0 then
      lbBool.Checked[p]:=true;
  end;

  // load FieldAsDataBar list
  lbDataBar.Items.Assign(lbFields.Items);
  for i:=0 to FAsDataBar.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsDataBar.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsDataBar.Strings[i]:=s + '=' + '';
    // set lbProgress
    p:=lbDataBar.Items.IndexOf(FAsDataBar.Names[i]);
    if p >= 0 then
      lbDataBar.Checked[p]:=true;
  end;

  // load FieldAsBool list
  lbStatusBar.Items.Assign(lbFields.Items);
  for i:=0 to FAsStatusBar.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsStatusBar.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsStatusBar.Strings[i]:=s + '=' + '';
    // set lbBool
    p:=lbStatusBar.Items.IndexOf(FAsStatusBar.Names[i]);
    if p >= 0 then
      lbStatusBar.Checked[p]:=true;
  end;

  // load AutoPickList
  lbPick.Items.Assign(lbFields.Items);
  for i:=0 to FAsPick.Count - 1 do
  begin
    p:=lbPick.Items.IndexOf(FAsPick.Strings[i]);
    if p >= 0 then
      lbPick.Checked[p]:=true;
  end;
  LoadDrawPick;

  // load ColorPickList
  lbColor.Items.Assign(lbFields.Items);
  for i:=0 to FAsColor.Count - 1 do
  begin
    p:=lbColor.Items.IndexOf(FAsColor.Strings[i]);
    if p >= 0 then
      lbColor.Checked[p]:=true;
  end;

  // load FieldAsDate
  lbDate.Items.Assign(lbFields.Items);
  for i:=0 to FAsDate.Count - 1 do
  begin
    p:=lbDate.Items.IndexOf(FAsDate.Strings[i]);
    if p >= 0 then
      lbDate.Checked[p]:=true;
  end;
  // load FieldAsGraphics
  lbGraphics.Items.Assign(lbFields.Items);
  for i:=0 to FAsGraphics.Count - 1 do
  begin
    p:=lbGraphics.Items.IndexOf(FAsGraphics.Strings[i]);
    if p >= 0 then
      lbGraphics.Checked[p]:=true;
  end;

  // load TitleImgList
  lbTitleImg.Items.Assign(lbFields.Items);
  for i:=0 to FTitleImg.Count - 1 do
  begin
    p:=lbTitleImg.Items.IndexOf(FTitleImg.Names[i]);
    if p >= 0 then
      lbTitleImg.Checked[p]:=true;
  end;

  // load DataImg
  cbDataImg.Items.Assign(lbFields.Items);
  FDataImgIni.SetStrings(FDataImg);

  // load groups
  FFieldsGroupsIni.SetStrings(FFieldsGroups);
  LoadGroups(false);
  self.chGrouppingOn.Checked:=FOptionsEx2.Groups.Active;

  // load TitleHints
  lbHints.Items.Assign(lbFields.Items);
  for i:=0 to FTitleHints.Count - 1 do
  begin
    p:=lbHints.Items.IndexOf(FTitleHints.Names[i]);
    if p >= 0 then
      lbHints.Checked[p]:=true;
  end;

  // load FilterButtons
  lbFilterFields.Items.Assign(lbFields.Items);
  for i:=0 to FFilterBtn.Count - 1 do
  begin
    p:=lbFilterFields.Items.IndexOf(FFilterBtn.Strings[i]);
    if p >= 0 then
      lbFilterFields.Checked[p]:=true;
  end;
  self.chFilterFunnelBtn.Checked:=FOptionsEx2.Filters.FunnelBtn;
  self.chFilterTextBar.Checked:=FOptionsEx2.Filters.TextBar;

  // load FooterRow
  lbFooterFields.Items.Assign(lbFields.Items);
  for i:=0 to FFooterRow.FieldFooterDefs.Count - 1 do
  begin
    p:=lbFooterFields.Items.IndexOf(FFooterRow.FieldFooterDefs.Names[i]);
    if p >= 0 then
      lbFooterFields.Checked[p]:=true;
  end;
  self.chFooterOn.Checked:=FFooterRow.FooterVisible;
end;

procedure TrDBGrid_DTEditForm.SetProps;
var
  i: Integer;
begin
  // set action control
  if not chEnaAll.Checked then
    Tag:=-1
  else
  begin
    Tag:=0;
    if not chEditGroup.Checked then
      Tag:=Tag or 1;
    if not chSort.Checked then
      Tag:=Tag or 2;
    if not chFilter.Checked then
      Tag:=Tag or 4;
    if not chColumn.Checked then
      Tag:=Tag or 8;
    if not chProps.Checked then
      Tag:=Tag or 16;
    if not chClose.Checked then
      Tag:=Tag or 128;

    if not chAdd.Checked then
      Tag:=Tag or 1024;
    if not chDuplic.Checked then
      Tag:=Tag or 256;
    if not chEdit.Checked then
      Tag:=Tag or 2048;
    if not chDelete.Checked then
      Tag:=Tag or 4096;
    if not chSaveAdd.Checked then
      Tag:=Tag or 512;
    if not chAutoEdit.Checked then
      Tag:=Tag or 8192;
  end;

  FAsPick.Clear;
  for i:=0 to lbPick.Items.Count - 1 do
    if lbPick.Checked[i] then
      FAsPick.Add(lbPick.Items[i]);

  FAsColor.Clear;
  for i:=0 to lbColor.Items.Count - 1 do
    if lbColor.Checked[i] then
      FAsColor.Add(lbColor.Items[i]);

  FAsDate.Clear;
  for i:=0 to lbDate.Items.Count - 1 do
    if lbDate.Checked[i] then
      FAsDate.Add(lbDate.Items[i]);

  FAsGraphics.Clear;
  for i:=0 to lbGraphics.Items.Count - 1 do
    if lbGraphics.Checked[i] then
      FAsGraphics.Add(lbGraphics.Items[i]);

  FFilterBtn.Clear;
  for i:=0 to lbFilterFields.Items.Count - 1 do
    if lbFilterFields.Checked[i] then
      FFilterBtn.Add(lbFilterFields.Items[i]);

  FDataImg.Clear;
  FDataImgIni.GetStrings(FDataImg);

  FFieldsGroups.Clear;
  FFieldsGroupsIni.GetStrings(FFieldsGroups);

  // self.FFooterRow.FooterVisible:=not self.FFooterRow.FooterVisible;
  // self.FFooterRow.FieldFooterDefs.Add('Test=1');
end;

// COLUMNS proc
procedure TrDBGrid_DTEditForm.LoadCol(KeepSelected: Boolean);
var
  i, oldId, oldTop: Integer;
begin
  // load columns
  oldId:=lbCol.ItemIndex;
  oldTop:=lbCol.TopIndex;
  lbCol.Items.BeginUpdate;
  try
    lbCol.Items.Clear;
    for i:=0 to Cs.Count - 1 do
      lbCol.Items.Add(Cs[i].Title.Caption);
    for i:=0 to Cs.Count - 1 do
    begin
      lbCol.Checked[i]:=Cs[i].Visible;
      with Gr.GetFieldGroupInfo(Cs[i].Field) do
        if IsGrouped and not IsMaster then
          lbCol.ItemEnabled[i]:=Gr.IsFieldGroupMasterVisible(Cs[i].Field);
    end;
    if KeepSelected then
    begin
      lbCol.TopIndex:=oldTop;
      if (oldId >= 0) and (oldId < lbCol.Items.Count) then
        lbCol.ItemIndex:=oldId;
      RefAll;
    end;
  finally
    lbCol.Items.EndUpdate;
  end;
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.AddCol(Fld: TField);
var
  C: TColumn;
  oldItemIndex: Integer;
begin
  oldItemIndex:=lbCol.ItemIndex;
  C:=Cs.Add;
  C.FieldName:=Fld.FieldName;
  C.Title.Caption:=ReplaceStr(eSep.Text, ' ', Fld.DisplayLabel, true, false);
  C.Title.Alignment:=C.Alignment;
  C.ReadOnly:=Fld.ReadOnly;
  C.Visible:=Fld.Visible;
  try
    if Assigned(Fld) then
      C.Width:=Fld.DisplayWidth * 4;
    if C.Width < 50 then
      C.Width:=50;
    if C.Width > 200 then
      C.Width:=200;
  except
  end;
  if (oldItemIndex < 0) or (oldItemIndex > Cs.Count - 1) then
    oldItemIndex:=Cs.Count - 1
  else
    Inc(oldItemIndex);
  C.Index:=oldItemIndex;
  LoadCol(false);
  lbCol.ItemIndex:=oldItemIndex;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.MoveICheckBox(List: TCheckListBox; old, new: Integer);
begin
  if not MoveCheckListBox(List, old, new) then
    Exit;
  Cs[old].Index:=new;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.MoveIListBox(List: TListBox; old, new: Integer);
begin
  if not MoveListBox(List, old, new) then
    Exit;
end;

procedure TrDBGrid_DTEditForm.pcChange(Sender: TObject);
begin
  if pc.ActivePage = tsGroup then
    LoadGroups(true);
end;

procedure TrDBGrid_DTEditForm.CheckI(act: Integer);
begin
  if not lbCol.ItemEnabled[act] then
    Exit;
  Cs[act].Visible:=lbCol.Checked[act];
  if Gr.GetFieldGroupInfo(Cs[act].Field).IsMaster then
  begin
    if (not Cs[act].Visible) then
      Gr.CollapseGroup(Cs[act].Field);
    LoadCol(true);
  end;
end;

procedure TrDBGrid_DTEditForm.RefAll;
begin
  gbColBottom.Enabled:=(lbCol.ItemIndex >= 0) and (lbCol.ItemIndex < Cs.Count) and (lbCol.ItemIndex < lbCol.Count);
  if gbColBottom.Enabled then
  begin
    lblFName.Caption:=Cs[lbCol.ItemIndex].FieldName;
    eTitle.Text:=lbCol.Items[lbCol.ItemIndex];
    chReadOnly.Checked:=Cs[lbCol.ItemIndex].ReadOnly;
    chReadOnly.Enabled:=true;
  end
  else
  begin
    lblFName.Caption:='';
    eTitle.Text:='';
  end;
  btUp.Enabled:=gbColBottom.Enabled;
  btDown.Enabled:=gbColBottom.Enabled;
  btCollapse.Enabled:=gbColBottom.Enabled and Gr.GetFieldGroupInfo(Cs[lbCol.ItemIndex].Field).IsMaster;
  btExpand.Enabled:=gbColBottom.Enabled and btCollapse.Enabled;
end;

procedure TrDBGrid_DTEditForm.lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=true;
  MoveICheckBox(lbCol, lbCol.ItemIndex, Y div lbCol.ItemHeight + lbCol.TopIndex);
end;

procedure TrDBGrid_DTEditForm.lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with Control as TCheckListBox do
  begin
    Canvas.FillRect(Rect);
    if Gr.GetFieldGroupInfo(Cs[Index].Field).IsMaster then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top, Items[Index]);
  end;
end;

procedure TrDBGrid_DTEditForm.btUpClick(Sender: TObject);
begin
  MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
end;

procedure TrDBGrid_DTEditForm.btDownClick(Sender: TObject);
begin
  MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
end;

procedure TrDBGrid_DTEditForm.lbColClickCheck(Sender: TObject);
begin
  CheckI(lbCol.ItemIndex);
end;

procedure TrDBGrid_DTEditForm.lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) and (ssCtrl in Shift) then
  begin
    MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
    Key:=0;
  end;
  if (Key = VK_DOWN) and (ssCtrl in Shift) then
  begin
    MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
    Key:=0;
  end;
  if (Key = VK_DELETE) then
  begin
    btDel.Click;
    Key:=0;
  end;
end;

procedure TrDBGrid_DTEditForm.btDelClick(Sender: TObject);
var
  i: Integer;
begin
  i:=lbCol.ItemIndex;
  if i = -1 then
    Exit;
  Cs.Delete(i);
  lbCol.Items.Delete(i);
  if i > lbCol.Items.Count - 1 then
    i:=lbCol.Items.Count - 1;
  lbCol.ItemIndex:=i;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.btDelAllClick(Sender: TObject);
begin
  if DlgQ('Delete all columns?') <> mrYes then
    Exit;
  Cs.Clear;
  lbCol.Clear;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.btDelNoFieldClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Delete all orphan columns (without field)?') <> mrYes then
    Exit;
  for i:=Cs.Count - 1 downto 0 do
    if lbFields.Items.IndexOf(Cs.Items[i].FieldName) < 0 then
    begin
      Cs.Delete(i);
      lbCol.Items.Delete(i);
    end;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.chEditGroupClick(Sender: TObject);
begin
  gbEdit.Visible:=chEditGroup.Checked;
end;

procedure TrDBGrid_DTEditForm.chEnaAllClick(Sender: TObject);
begin
  gbActions.Visible:=chEnaAll.Checked;
end;

procedure TrDBGrid_DTEditForm.chFilterFunnelBtnClick(Sender: TObject);
begin
  FOptionsEx2.Filters.FunnelBtn:=chFilterFunnelBtn.Checked;
end;

procedure TrDBGrid_DTEditForm.chFilterTextBarClick(Sender: TObject);
begin
  FOptionsEx2.Filters.TextBar:=chFilterTextBar.Checked;
end;

procedure TrDBGrid_DTEditForm.chFooterOnClick(Sender: TObject);
begin
  FFooterRow.FooterVisible:=self.chFooterOn.Checked;
end;

procedure TrDBGrid_DTEditForm.chGrouppingOnClick(Sender: TObject);
begin
  if not chGrouppingOn.Checked then
    FOptionsEx2.Groups.Active:=false;
  btGroupUpdateAll.Click;
end;

procedure TrDBGrid_DTEditForm.chNormalClick(Sender: TObject);
begin
  UpdateFooterSetting;
end;

procedure TrDBGrid_DTEditForm.btMoveClick(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to lbFields.Items.Count - 1 do
    if lbFields.Selected[i] then
      AddCol(Flds[i]);
  // LoadProps;
end;

procedure TrDBGrid_DTEditForm.btMoveAllClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Add all columns?') <> mrYes then
    Exit;
  for i:=0 to lbFields.Items.Count - 1 do
    lbFields.Selected[i]:=true;
  btMove.Click;
end;

procedure TrDBGrid_DTEditForm.lbColClick(Sender: TObject);
begin
  RefAll;
end;

procedure TrDBGrid_DTEditForm.eTitleChange(Sender: TObject);
begin
  if not eTitle.Focused then
    Exit;
  lbCol.Items[lbCol.ItemIndex]:=eTitle.Text;
  Cs[lbCol.ItemIndex].Title.Caption:=eTitle.Text;
end;

procedure TrDBGrid_DTEditForm.chReadOnlyClick(Sender: TObject);
begin
  if not chReadOnly.Focused then
    Exit;
  Cs[lbCol.ItemIndex].ReadOnly:=chReadOnly.Checked;
end;

procedure TrDBGrid_DTEditForm.eTitleEnter(Sender: TObject);
begin
  btNext.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eTitleExit(Sender: TObject);
begin
  btNext.Default:=false;
end;

procedure TrDBGrid_DTEditForm.btNextClick(Sender: TObject);
begin
  if lbCol.ItemIndex < lbCol.Items.Count - 1 then
    lbCol.ItemIndex:=lbCol.ItemIndex + 1;
  lbColClick(nil);
end;

// LINK proc
procedure TrDBGrid_DTEditForm.lbLinkClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbLink.Checked[lbLink.ItemIndex] then
  begin
    i:=FAsLink.IndexOfName(lbLink.Items[lbLink.ItemIndex]);
    if i >= 0 then
      FAsLink.Delete(i);
  end
  else
  begin
    FAsLink.Add(lbLink.Items[lbLink.ItemIndex] + '=' + cbLinkType.Items[0]);
  end;
end;

procedure TrDBGrid_DTEditForm.lbLinkClick(Sender: TObject);
begin
  cbLinkType.ItemIndex:=-1;
  cbLinkType.Enabled:=lbLink.Checked[lbLink.ItemIndex];
  if cbLinkType.Enabled then
    cbLinkType.ItemIndex:=cbLinkType.Items.IndexOf(FAsLink.Values[lbLink.Items[lbLink.ItemIndex]]);
end;

procedure TrDBGrid_DTEditForm.cbLinkTypeExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FAsLink.IndexOfName(lbLink.Items[lbLink.ItemIndex]);
  if i >= 0 then
    FAsLink.Values[lbLink.Items[lbLink.ItemIndex]]:=cbLinkType.Text;
end;

// PICKLIST proc
procedure TrDBGrid_DTEditForm.lbPickClickCheck(Sender: TObject);
begin
  LoadDrawPick;
end;

procedure TrDBGrid_DTEditForm.StoreDrawPick;
var
  i: Integer;
begin
  FDrawDropDown.Clear;
  for i:=0 to lbDrawPick.Items.Count - 1 do
    if lbDrawPick.Checked[i] then
      FDrawDropDown.Add(lbDrawPick.Items[i]);
end;

procedure TrDBGrid_DTEditForm.LoadDrawPick;
var
  i: Integer;
begin
  lbDrawPick.Items.Clear;
  for i:=0 to lbPick.Items.Count - 1 do
    if lbPick.Checked[i] then
      lbDrawPick.Items.Add(lbPick.Items[i]);
  for i:=0 to lbDrawPick.Items.Count - 1 do
    lbDrawPick.Checked[i]:=FDrawDropDown.IndexOf(lbDrawPick.Items[i]) >= 0;
end;

procedure TrDBGrid_DTEditForm.lbDataBarClick(Sender: TObject);
var
  s: string;
  vmin, vmax: double;
  valType: TrDataBarText;
  CFrom, CTo: TColor;
begin
  eDatabarMin.AsInteger:=0;
  eDatabarMax.AsInteger:=0;
  cbDataBarText.ItemIndex:=-1;
  cbDatabarColorFrom.Selected:=clNone;
  cbDatabarColorTo.Selected:=clNone;
  gbDataBarParams.Enabled:=lbDataBar.Checked[lbDataBar.ItemIndex];
  self.gbDatabarDemo.Visible:=gbDataBarParams.Enabled;
  if gbDataBarParams.Enabled then
  begin
    s:=FAsDataBar.Values[lbDataBar.Items[lbDataBar.ItemIndex]];
    if Gr.Fields_GetDataBarSettings('*' + s, vmin, vmax, valType, CFrom, CTo) then
    begin
      eDatabarMin.Value:=vmin;
      eDatabarMax.Value:=vmax;
      cbDataBarText.ItemIndex:=ord(valType);
      cbDatabarColorFrom.Selected:=CFrom;
      cbDatabarColorTo.Selected:=CTo;
      RefDatabarDemo;
    end
    else
    begin
      eDatabarMax.Value:=100;
      cbDataBarText.ItemIndex:=0;
      eDatabarMinExit(nil);
    end;
  end;
end;

procedure TrDBGrid_DTEditForm.lbDataBarClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbDataBar.Checked[lbDataBar.ItemIndex] then
  begin
    i:=FAsDataBar.IndexOfName(lbDataBar.Items[lbDataBar.ItemIndex]);
    if i >= 0 then
      FAsDataBar.Delete(i);
  end
  else
  begin
    FAsDataBar.Add(lbDataBar.Items[lbDataBar.ItemIndex] + '=' + '');
  end;
end;

procedure TrDBGrid_DTEditForm.eDatabarMinExit(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  i:=FAsDataBar.IndexOfName(lbDataBar.Items[lbDataBar.ItemIndex]);
  if i >= 0 then
  begin
    s:=Gr.Fields_SetDataBarSettings('', eDatabarMin.Value, eDatabarMax.Value, TrDataBarText(cbDataBarText.ItemIndex), cbDatabarColorFrom.Selected,
      cbDatabarColorTo.Selected);
    FAsDataBar.Values[lbDataBar.Items[lbDataBar.ItemIndex]]:=s;
    RefDatabarDemo;
  end;
end;

procedure TrDBGrid_DTEditForm.RefDatabarDemo;
var
  CFrom, CTo: TColor;
begin
  CFrom:=cbDatabarColorFrom.Selected;
  if CFrom = clNone then
    CFrom:=clSkyBlue;
  CTo:=cbDatabarColorTo.Selected;
  if CTo = clNone then
    CTo:=clWhite;
  gbDatabarDemo.FrameColor:=CFrom;
  gbDatabarDemo.GradientColorFrom:=CFrom;
  gbDatabarDemo.GradientColorTo:=CTo;
end;

procedure TrDBGrid_DTEditForm.lbStatusBarClick(Sender: TObject);
var
  s: string;
  vmax: Integer;
  BarType: TrStatusBarType;
  CFrom, CTo: TColor;
begin
  eStatusSteps.AsInteger:=0;
  cbStatusType.ItemIndex:=-1;
  cbStatusColorAll.Selected:=clNone;
  cbStatusColorDone.Selected:=clNone;
  gbStatusBarParams.Enabled:=lbStatusBar.Checked[lbStatusBar.ItemIndex];
  if gbStatusBarParams.Enabled then
  begin
    s:=FAsStatusBar.Values[lbStatusBar.Items[lbStatusBar.ItemIndex]];
    if Gr.Fields_GetStatusBarSettings('*' + s, vmax, BarType, CFrom, CTo) then
    begin
      eStatusSteps.AsInteger:=vmax;
      cbStatusType.ItemIndex:=ord(BarType);
      cbStatusColorAll.Selected:=CFrom;
      cbStatusColorDone.Selected:=CTo;
    end
    else
    begin
      eStatusSteps.Value:=5;
      cbStatusType.ItemIndex:=0;
      eStatusStepsExit(nil);
    end;
  end;
end;

procedure TrDBGrid_DTEditForm.lbStatusBarClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbStatusBar.Checked[lbStatusBar.ItemIndex] then
  begin
    i:=FAsStatusBar.IndexOfName(lbStatusBar.Items[lbStatusBar.ItemIndex]);
    if i >= 0 then
      FAsStatusBar.Delete(i);
  end
  else
  begin
    FAsStatusBar.Add(lbStatusBar.Items[lbStatusBar.ItemIndex] + '=' + '');
  end;
end;

procedure TrDBGrid_DTEditForm.eStatusStepsExit(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  i:=FAsStatusBar.IndexOfName(lbStatusBar.Items[lbStatusBar.ItemIndex]);
  if i >= 0 then
  begin
    s:=Gr.Fields_SetStatusBarSettings('', eStatusSteps.AsInteger, TrStatusBarType(cbStatusType.ItemIndex), cbStatusColorAll.Selected,
      cbStatusColorDone.Selected);
    FAsStatusBar.Values[lbStatusBar.Items[lbStatusBar.ItemIndex]]:=s;
  end;
end;

// BOOLFIELDS proc
procedure TrDBGrid_DTEditForm.lbBoolClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbBool.Checked[lbBool.ItemIndex] then
  begin
    i:=FAsBool.IndexOfName(lbBool.Items[lbBool.ItemIndex]);
    if i >= 0 then
      FAsBool.Delete(i);
  end
  else
  begin
    FAsBool.Add(lbBool.Items[lbBool.ItemIndex] + '=' + rDefBoolValue);
  end;
end;

procedure TrDBGrid_DTEditForm.lbBoolClick(Sender: TObject);
begin
  eBoolVal.Text:='';
  eBoolVal.Enabled:=lbBool.Checked[lbBool.ItemIndex];
  if eBoolVal.Enabled then
    eBoolVal.Text:=FAsBool.Values[lbBool.Items[lbBool.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.eBoolValExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FAsBool.IndexOfName(lbBool.Items[lbBool.ItemIndex]);
  if i >= 0 then
    FAsBool.Values[lbBool.Items[lbBool.ItemIndex]]:=eBoolVal.Text;
end;

// TITLEIMAGE proc
procedure TrDBGrid_DTEditForm.lbTitleImgClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbTitleImg.Checked[lbTitleImg.ItemIndex] then
  begin
    i:=FTitleImg.IndexOfName(lbTitleImg.Items[lbTitleImg.ItemIndex]);
    if i >= 0 then
      FTitleImg.Delete(i);
  end
  else
  begin
    FTitleImg.Add(lbTitleImg.Items[lbTitleImg.ItemIndex] + '=0');
  end;
end;

procedure TrDBGrid_DTEditForm.lbHintsClick(Sender: TObject);
begin
  eHint.Text:='';
  eHint.Enabled:=lbHints.Checked[lbHints.ItemIndex];
  if eHint.Enabled then
    eHint.Text:=FTitleHints.Values[lbHints.Items[lbHints.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.lbHintsClickCheck(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  s:=lbHints.Items[lbHints.ItemIndex];
  if not lbHints.Checked[lbHints.ItemIndex] then
  begin
    i:=FTitleHints.IndexOfName(s);
    if i >= 0 then
      FTitleHints.Delete(i);
  end
  else
  begin
    FTitleHints.Add(s + '=' + s);
  end;
end;

procedure TrDBGrid_DTEditForm.eHintExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FTitleHints.IndexOfName(lbHints.Items[lbHints.ItemIndex]);
  if i >= 0 then
    FTitleHints.Values[lbHints.Items[lbHints.ItemIndex]]:=eHint.Text;
end;

procedure TrDBGrid_DTEditForm.lbTitleImgClick(Sender: TObject);
begin
  eTitleImg.AsInteger:=-1;
  eTitleImg.Enabled:=lbTitleImg.Checked[lbTitleImg.ItemIndex];
  UpDownTitleImg.Enabled:=eTitleImg.Enabled;
  if eTitleImg.Enabled then
    eTitleImg.Text:=FTitleImg.Values[lbTitleImg.Items[lbTitleImg.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.eTitleImgExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FTitleImg.IndexOfName(lbTitleImg.Items[lbTitleImg.ItemIndex]);
  if i >= 0 then
    FTitleImg.Values[lbTitleImg.Items[lbTitleImg.ItemIndex]]:=eTitleImg.Text;
end;

procedure TrDBGrid_DTEditForm.eTitleImgChange(Sender: TObject);
begin
  TitleImg.Picture.Bitmap:=nil;
  // UpDownTitleImg.Position:=eTitleImg.AsInteger;
  if Assigned(FTitleImgList) and (eTitleImg.AsInteger >= 0) and (eTitleImg.AsInteger < FTitleImgList.Count) then
  begin
    FTitleImgList.GetBitmap(eTitleImg.AsInteger, TitleImg.Picture.Bitmap);
  end;
end;

// DataImage proc
procedure TrDBGrid_DTEditForm.SetIniSection;
var
  i: Integer;
begin
  FDataImgIni.EraseSection(cbDataImg.Text);
  for i:=0 to lbDataImg.Items.Count - 1 do
    FDataImgIni.WriteString(cbDataImg.Text, lbDataImg.Items.Names[i], lbDataImg.Items.Values[lbDataImg.Items.Names[i]]);
end;

procedure TrDBGrid_DTEditForm.cbDataImgChange(Sender: TObject);
begin
  lbDataImg.Items.Clear;
  FDataImgIni.ReadSectionValues(cbDataImg.Text, lbDataImg.Items);
  lbDataImgClick(self);
end;

procedure TrDBGrid_DTEditForm.lbDataImgClick(Sender: TObject);
var
  s: string;
begin
  eDataImgVal.Text:='';
  eDataImgText.Text:='';
  eDataImgIdx.AsInteger:=-1;
  eDataImgVal.Enabled:=lbDataImg.ItemIndex >= 0;
  eDataImgText.Enabled:=eDataImgVal.Enabled;
  eDataImgIdx.Enabled:=eDataImgVal.Enabled;
  UpDownDataImg.Enabled:=eDataImgVal.Enabled;
  if lbDataImg.ItemIndex < 0 then
    Exit;
  eDataImgVal.Text:=lbDataImg.Items.Names[lbDataImg.ItemIndex];
  s:=lbDataImg.Items.Values[eDataImgVal.Text];
  try
    StrToInt(s);
    eDataImgIdx.Text:=s;
  except
    eDataImgText.Text:=s;
    eDataImgIdx.Enabled:=false;
    UpDownDataImg.Enabled:=false;
  end;
end;

procedure TrDBGrid_DTEditForm.lbDataImgDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=true;
  MoveIListBox(lbDataImg, lbDataImg.ItemIndex, Y div lbDataImg.ItemHeight + lbDataImg.TopIndex);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.lbDataImgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) and (ssCtrl in Shift) then
  begin
    MoveIListBox(lbDataImg, lbDataImg.ItemIndex, lbDataImg.ItemIndex - 1);
    Key:=0;
    SetIniSection;
  end;
  if (Key = VK_DOWN) and (ssCtrl in Shift) then
  begin
    MoveIListBox(lbDataImg, lbDataImg.ItemIndex, lbDataImg.ItemIndex + 1);
    Key:=0;
    SetIniSection;
  end;
end;

procedure TrDBGrid_DTEditForm.lbDrawPickClickCheck(Sender: TObject);
begin
  StoreDrawPick;
end;

procedure TrDBGrid_DTEditForm.eDataImgValExit(Sender: TObject);
var
  s: string;
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  if eDataImgVal.Text = '' then
  begin
    eDataImgVal.SetFocus;
    Exit;
  end;
  s:=eDataImgText.Text;
  eDataImgIdx.Enabled:=s = '';
  UpDownDataImg.Enabled:=s = '';
  if s = '' then
    s:=eDataImgIdx.Text;
  lbDataImg.Items[lbDataImg.ItemIndex]:=eDataImgVal.Text + '=' + s;
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDDelClick(Sender: TObject);
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  lbDataImg.Items.Delete(lbDataImg.ItemIndex);
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDAddClick(Sender: TObject);
begin
  lbDataImg.Items.Add('*=0');
  lbDataImg.ItemIndex:=lbDataImg.Items.Count - 1;
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.eDataImgIdxChange(Sender: TObject);
begin
  DataImg.Picture.Bitmap:=nil;
  // UpDownDataImg.Position:=eDataImgIdx.AsInteger;
  if Assigned(FDataImgList) and (eDataImgIdx.AsInteger >= 0) and (eDataImgIdx.AsInteger < FDataImgList.Count) then
  begin
    FDataImgList.GetBitmap(eDataImgIdx.AsInteger, DataImg.Picture.Bitmap);
  end;
end;

procedure TrDBGrid_DTEditForm.cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with Control as TComboBox do
  begin
    Canvas.FillRect(Rect);
    if FDataImgIni.SectionExists(Items[Index]) then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top + 1, Items[Index]);
  end;
end;

procedure TrDBGrid_DTEditForm.UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eTitleImg.AsInteger:=eTitleImg.AsInteger + 1;
  if Direction = updDown then
    eTitleImg.AsInteger:=eTitleImg.AsInteger - 1;
  eTitleImg.SetFocus;
end;

procedure TrDBGrid_DTEditForm.UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger + 1;
  if Direction = updDown then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger - 1;
  eDataImgIdx.SetFocus;
end;

// GROUPFields proc
procedure TrDBGrid_DTEditForm.eGroupTitleEnter(Sender: TObject);
begin
  btGroupUpdateAll.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eGroupTitleExit(Sender: TObject);
begin
  btGroupUpdateAll.Default:=false;
  btGroupUpdateClick(Sender);
end;

procedure TrDBGrid_DTEditForm.cgGroupTitleColorExit(Sender: TObject);
begin
  btGroupUpdateAll.Default:=false;
  btGroupUpdateClick(nil);
end;

procedure TrDBGrid_DTEditForm.LoadGroups(KeepSelected: Boolean);
var
  i: Integer;
begin
  i:=lbGroups.ItemIndex;
  FFieldsGroupsIni.ReadSections(lbGroups.Items);
  lbGroups.ItemIndex:=-1;
  if KeepSelected and (i >= 0) and (i < lbGroups.Items.Count) then
    lbGroups.ItemIndex:=i;
  lbGroupsClick(nil);
end;

function TrDBGrid_DTEditForm.GetSelGroupName: string;
begin
  if lbGroups.ItemIndex >= 0 then
    Result:=lbGroups.Items[lbGroups.ItemIndex]
  else
    Result:='';
end;

procedure TrDBGrid_DTEditForm.Label22GetParameter(Sender: TObject; var ParamStr: string);
begin
  ParamStr:=DataImagesFieldCfg;
end;

procedure TrDBGrid_DTEditForm.lbGroupFieldsClickCheck(Sender: TObject);
var
  i, idx: Integer;
  s: string;
begin
  i:=lbGroupFields.ItemIndex;
  if lbGroupFields.Checked[i] then
  begin
    // add grouped field
    if cbGroupMaster.Items.Count = 0 then
      // first field as Master
      s:='M'
    else
      s:='0';
    FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, s);
    cbGroupMaster.Items.Add(lbGroupFields.Items[i]);
    if cbGroupMaster.Items.Count = 1 then
      cbGroupMaster.ItemIndex:=0;
  end
  else
  begin
    // remove grouped field
    FFieldsGroupsIni.DeleteKey(GetSelGroupName, Cs[i].FieldName);
    idx:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[i]);
    if idx >= 0 then
      cbGroupMaster.Items.Delete(idx);
  end;
end;

procedure TrDBGrid_DTEditForm.cbGroupMasterChange(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to lbGroupFields.Items.Count - 1 do
  begin
    if lbGroupFields.Checked[i] then
      FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, '0');
  end;
  i:=lbGroupFields.Items.IndexOf(cbGroupMaster.Items[cbGroupMaster.ItemIndex]);
  if i >= 0 then
    FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, 'M');
end;

procedure TrDBGrid_DTEditForm.LoadGroupFields;
var
  FieldList, L: TStrings;
  i, idx: Integer;
begin
  // load group columns list and reset state
  lbGroupFields.Items.Assign(lbCol.Items);
  lbGroupFields.CheckAll(cbUnchecked);
  cbGroupMaster.Items.Clear;
  FieldList:=TStringList.Create;
  try
    // load list of fields in the group
    L:=TStringList.Create;
    try
      FFieldsGroupsIni.ReadSectionValues(GetSelGroupName, L);
      FieldList.Clear;
      for i:=0 to L.Count - 1 do
        if SameText(L.ValueFromIndex[i], 'M') then
          FieldList.Insert(0, L.Names[i])
        else
          FieldList.Add(L.Names[i]);
    finally
      FreeAndNil(L);
    end;
    // remove non existing fields from Group definition
    for i:=0 to FieldList.Count - 1 do
    begin
      if lbFields.Items.IndexOf(FieldList[i]) < 0 then
        FFieldsGroupsIni.DeleteKey(GetSelGroupName, FieldList[i]);
    end;
    // check grouped fields
    for i:=0 to Cs.Count - 1 do
    begin
      idx:=FieldList.IndexOf(Cs[i].FieldName);
      if idx >= 0 then
      begin
        lbGroupFields.Checked[i]:=true;
        cbGroupMaster.Items.Add(lbGroupFields.Items[i]);
        if idx = 0 then
          cbGroupMaster.ItemIndex:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[i]);
      end;
    end;
  finally
    FreeAndNil(FieldList);
  end;
end;

procedure TrDBGrid_DTEditForm.lbGroupsClick(Sender: TObject);
var
  GroupId: Integer;
  GrTitle, Content: string;
  FontColor, LineColor: TColor;
  Locked: Boolean;
begin
  gbGroupBottom.Enabled:=lbGroups.ItemIndex >= 0;
  gbRightGroups.Enabled:=gbGroupBottom.Enabled;
  if gbGroupBottom.Enabled then
  begin
    if Gr.Fields_GetGroupSettings(GetSelGroupName, GroupId, GrTitle, Content, FontColor, LineColor, Locked, nil) then
    begin
      eGroupTitle.Text:=GrTitle;
      cgGroupTitleColor.Selected:=FontColor;
      cgGroupLineColor.Selected:=LineColor;
      eGroupMasterMask.Text:=Content;
      chGroupLock.Checked:=Locked;
      LoadGroupFields;
    end;
    lbGroups.Tag:=GroupId;
  end
  else
  begin
    lbGroups.Tag:=0;
    eGroupTitle.Text:='';
    cgGroupTitleColor.Selected:=clNone;
    cgGroupLineColor.Selected:=clNone;
    lbGroupFields.CheckAll(cbUnchecked);
  end;
  btDelGroup.Enabled:=gbGroupBottom.Enabled;
  btGroupCollapse.Enabled:=gbGroupBottom.Enabled;
  btGroupExpand.Enabled:=gbGroupBottom.Enabled;
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateClick(Sender: TObject);
var
  newsec: string;
  L: TStringList;
  i: Integer;
begin
  if Sender = btNone1 then
    cgGroupTitleColor.Selected:=clNone;
  if Sender = btNone2 then
    cgGroupLineColor.Selected:=clNone;
  newsec:=Gr.Fields_SetGroupSettings(lbGroups.Tag, eGroupTitle.Text, eGroupMasterMask.Text, cgGroupTitleColor.Selected, cgGroupLineColor.Selected,
    chGroupLock.Checked, nil);
  L:=TStringList.Create;
  try
    // update section name
    FFieldsGroupsIni.GetStrings(L);
    i:=L.IndexOf('[' + GetSelGroupName + ']');
    if i >= 0 then
      L[i]:='[' + newsec + ']';
    FFieldsGroupsIni.SetStrings(L);
    LoadGroups(true);
  finally
    FreeAndNil(L);
  end;
end;

procedure TrDBGrid_DTEditForm.btNewGroupClick(Sender: TObject);
var
  ns: string;
  i, id, max: Integer;
begin
  // find max used id
  max:=0;
  for i:=0 to lbGroups.Items.Count - 1 do
  begin
    id:=StrToIntDef(rtool.FindStrPart(lbGroups.Items[i], GroupHeaderSep, 1, true), -1);
    if id > max then
      max:=id;
  end;
  // generate new group
  ns:=IntToStr(max + 1) + GroupHeaderSep; // + GroupHeaderSep + GroupHeaderSep;
  // create section by temp value
  FFieldsGroupsIni.WriteString(ns, '_temp_', '0');
  FFieldsGroupsIni.DeleteKey(ns, '_temp_');
  LoadGroups(false);
end;

procedure TrDBGrid_DTEditForm.btDelGroupClick(Sender: TObject);
begin
  if lbGroups.ItemIndex >= 0 then
  begin
    FFieldsGroupsIni.EraseSection(GetSelGroupName);
    LoadGroups(false);
    btGroupUpdateAll.Click;
  end;
end;

procedure TrDBGrid_DTEditForm.btGroupAddMaskAnchorClick(Sender: TObject; LinkName: string);
begin
  if lbGroupFields.ItemIndex >= 0 then
  begin
    eGroupMasterMask.Text:=eGroupMasterMask.Text + '<<' + Cs[lbGroupFields.ItemIndex].FieldName + '>>';
    btGroupUpdateClick(nil);
  end;
end;

procedure TrDBGrid_DTEditForm.btGroupCollapseClick(Sender: TObject);
var
  id: Integer;
begin
  btGroupUpdateAll.Click;
  id:=StrToIntDef(rtool.FindStrPart(GetSelGroupName, GroupHeaderSep, 1, true), -1);
  if Sender = btGroupCollapse then
    Gr.CollapseGroup(id)
  else
    Gr.ExpandGroup(id);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateAllClick(Sender: TObject);
begin
  if btGroupUpdate.Enabled then
    btGroupUpdate.Click;
  FFieldsGroups.Clear;
  FFieldsGroupsIni.GetStrings(FFieldsGroups);
  Gr.FixedGroupedCol(chGrouppingOn.Checked and (lbGroups.Items.Count > 0));
  LoadCol(false);
  lbGroupsClick(nil);
end;

procedure TrDBGrid_DTEditForm.lbFooterFieldsClick(Sender: TObject);
var
  s: string;
begin
  s:=lbFooterFields.Items[lbFooterFields.ItemIndex];
  LoadFooterCfg(s, FFooterRow.FieldFooterDefs.Values[s]);
end;

procedure TrDBGrid_DTEditForm.lbFooterFieldsClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbFooterFields.Checked[lbFooterFields.ItemIndex] then
  begin
    i:=FFooterRow.FieldFooterDefs.IndexOfName(lbFooterFields.Items[lbFooterFields.ItemIndex]);
    if i >= 0 then
      FFooterRow.FieldFooterDefs.Delete(i);
  end
  else
  begin
    FFooterRow.FieldFooterDefs.Add(lbFooterFields.Items[lbFooterFields.ItemIndex] + '=');
  end;
end;

procedure TrDBGrid_DTEditForm.btAddFooterTagClick(Sender: TObject);
begin
  eFooterMask.Text:=eFooterMask.Text + self.cbFooterTags.Text;
  chNormalClick(nil);
end;

procedure TrDBGrid_DTEditForm.LoadFooterCfg(FieldName, Params: string);
var
  cfg: string;
begin
  isFooterUpdating:=true;
  try
    eFooterMask.Text:='';
    chNormal.Checked:=false;
    chBold.Checked:=false;
    chItalic.Checked:=false;
    chUnderline.Checked:=false;
    gbAlignment.ItemIndex:=0;
    cbColor.Selected:=clNone;
    eFontSize.AsInteger:=0;

    gbRight7.Enabled:=lbFooterFields.Checked[lbFooterFields.ItemIndex];
    if gbRight7.Enabled then
    begin
      lblTest.Font.Style:=[];
      lblTest.Font.Size:=0;
      lblTest.Font.Color:=clNone;

      eFooterMask.Text:=rtool.RemoveStrPart(Params, FieldListSep);
      while Params <> '' do
      begin
        cfg:=AnsiUpperCase(Trim(rtool.RemoveStrPart(Params, FieldListSep)));
        if cfg = 'L' then
          gbAlignment.ItemIndex:=1
        else
          if cfg = 'C' then
            gbAlignment.ItemIndex:=2
          else
            if cfg = 'R' then
              gbAlignment.ItemIndex:=3
            else
              if cfg = 'N' then
                chNormal.Checked:=true
              else
                UseFontFormatParams(lblTest.Font, cfg);
      end;

      chBold.Checked:=fsBold in lblTest.Font.Style;
      chItalic.Checked:=fsItalic in lblTest.Font.Style;
      chUnderline.Checked:=fsUnderline in lblTest.Font.Style;
      cbColor.Selected:=lblTest.Font.Color;
      eFontSize.AsInteger:=lblTest.Font.Size;
    end;
  finally
    isFooterUpdating:=false;
  end;
end;

procedure TrDBGrid_DTEditForm.UpdateFooterSetting;
var
  s: string;
begin
  if isFooterUpdating then
    Exit;
  s:=eFooterMask.Text + FieldListSep;
  if chNormal.Checked then
    s:=s + 'N;';
  if chBold.Checked then
    s:=s + 'B;';
  if chItalic.Checked then
    s:=s + 'I;';
  if chUnderline.Checked then
    s:=s + 'U;';
  case gbAlignment.ItemIndex of
    1:
      s:=s + 'L;';
    2:
      s:=s + 'C;';
    3:
      s:=s + 'R;';
  end;
  if cbColor.Selected <> clNone then
    s:=s + rpictool.ColorToString(cbColor.Selected, false) + FieldListSep;
  if eFontSize.AsInteger > 0 then
    s:=s + IntToStr(eFontSize.AsInteger) + FieldListSep;
  // if s = '' then s:='0';
  FFooterRow.FieldFooterDefs.Values[lbFooterFields.Items[lbFooterFields.ItemIndex]]:=s;
  // RefFooterExample(s);
end;

end.
